PSystem ps;
Arcball arcball;

class RectParticle extends Particle {
public RectParticle() {}
  void draw() {
    push();
    stroke(100, 100, 100, 100);
    translate(pos[0], pos[1], pos[2]);
    if (fixed()) {
      fill(#FF0000);
    }
    else {
      fill(#DDDDDD);
    }
    box(5, 5, 5);
    pop();
  }
}

int PARTICLES_Z = 1;
int PARTICLES_Y = 8;
int PARTICLES_X = 8;

float unitLength = 30;

Particle[][][] particles;

public void setup() {
  size(500, 500);
  ps = (PSystem)loadPlugin("PSystem");
  arcball = (Arcball)loadPlugin("Arcball");
  
  //ps.useImplicitEuler = false;
  
  ps.setGravity(5.03);
  ps.defaultMass = 1.0f;
  ps.defaultSpringRestLength = 30;
  ps.defaultSpringStrength = 10.0f;
  ps.defaultSpringDamping = 1.0f;

  makeGrid();

  particles[0][0][0].fix();
  particles[0][PARTICLES_Y-1][0].fix();

  //ps.timeStep = 0.1f;
}

public void loop() {
  background(#99CCCC);
  arcball.run();
  
  particles[0][PARTICLES_Y-1][0].pos[0] = mouseX;
  particles[0][PARTICLES_Y-1][0].pos[1] = mouseY;
  particles[0][PARTICLES_Y-1][0].pos[2] = 0;

  
  ps.draw();
}

void makeGrid() {
  particles = new Particle[PARTICLES_X][PARTICLES_Y][PARTICLES_Z];

  for (int x = 0; x < PARTICLES_X; x++) {
    for (int z = 0; z < PARTICLES_Z; z++) {
      for (int y = 0; y < PARTICLES_Y; y++) {
        particles[x][y][z] = new Particle();
        ps.addParticle(particles[x][y][z]);
        particles[x][y][z].setPos(unitLength*x,unitLength*y,unitLength*z);

        if (x > 0) {
          Spring s = new Spring(particles[x][y][z], particles[x-1][y][z]);
          ps.addForce(s);
        }
        if (y > 0) {
          Spring s = new Spring(particles[x][y][z], particles[x][y-1][z]);
          ps.addForce(s);
        }
        if (z > 0) {
          Spring s = new Spring(particles[x][y][z], particles[x][y][z-1]);
          ps.addForce(s);
        }
      }
    }
  }
  
}
