// Vector Raster
// by REAS <http://www.groupc.net>

// Click and drag the mouse to create a new line.
// Release the mouse button to inscribe the line.

// Created 23 October 2002

int beginLineX, beginLineY;
int buffer[] = new int[200*200];
color lineColor;

void setup() {
  size(200, 200);
  background(102);
  stroke(255);
  lineColor = color(102, 153, 204);
  for(int i=0; i<width*height; i++) {
    buffer[i] = color(51, 51, 51);
  }
}

void refresh(){
  for(int i=0; i<width*height; i++) {
    buffer[i] = color(51, 51, 51);
  }
}

void loop() {
  for(int i=0; i<width*height; i++) {
    pixels[i] = buffer[i]; 
  }
  if(mousePressed) {
    line(beginLineX, beginLineY, mouseX, mouseY);
  }
}

void mousePressed() {
  beginLineX = mouseX;
  beginLineY = mouseY;
}

void mouseReleased() {
  lineDraw(beginLineX, beginLineY, mouseX, mouseY, lineColor);
}


// Simple, unefficient line drawing method
public void lineDraw(int x0, int y0, int x1, int y1, color c)
{
  int dx = x1 - x0;
  int dy = y1 - y0;
  addPixel(c, x0, y0);
  if (abs(dx) > abs(dy)) {  // slope < 1
    float m = (float)dy / (float)dx; // compute slope
    float b = y0 - m*x0;
    dx = (dx < 0) ? -1 : 1;
    while (x0 != x1) {
      x0 += dx;
      addPixel(c, x0, Math.round(m*x0 + b));
    }
  } else
  if (dy != 0) { // slope >= 1
    float m = (float)dx / (float)dy; // compute slope
    float b = x0 - m*y0;
    dy = (dy < 0) ? -1 : 1;
    while (y0 != y1) {
      y0 += dy;
      addPixel(c, Math.round(m*y0 + b), y0);
    }
  }
}

// Helper method for lineDraw
void addPixel(color c, int x, int y) 
{
  if(!invalid(x, y)) {  
    buffer[y*width+x] = c;
  }
}

// Helper method for lineDraw
boolean invalid(int x, int y) {
  return ((x < 0) || (x >= width) || (y < 0) || (y >= height));
}
