// Image button
// by REAS <http://www.groupc.net>

// Loading images and using them to create a button

// Created 10 February 2003

ImageButton button;

void setup()
{
  size(200, 200);
  background(102, 102, 102);
  
  // Define and create image button
  BImage b = loadImage("base.gif");
  BImage r = loadImage("roll.gif");
  BImage d = loadImage("down.gif");
  int x = width/2 - b.width/2;
  int y = height/2 - b.height/2; 
  int w = b.width;
  int h = b.height;
  button = new ImageButton(x, y, w, h, b, r, d);
}

void loop()
{
  button.update();
  button.display();
}

class Button
{
  int x, y;
  int w, h;
  color basecolor, highlightcolor;
  color currentcolor;
  boolean over = false;
  boolean pressed = false;   
  
  void pressed() 
  {
    if(over && mousePressed) {
      pressed = true;
    } else {
      pressed = false;
    }    
  }
}

class ImageButton extends Button
{
  BImage base;
  BImage roll;
  BImage down;
  BImage currentimage;

  ImageButton(int _x, int _y, int _w, int _h, BImage b, BImage r, BImage d) 
  {
    x = _x;
    y = _y;
    w = _w;
    h = _h;
    base = b;
    roll = r;
    down = d;
    currentimage = base;
  }
  
  void update() 
  {
    over();
    pressed();
    if(pressed) {
      currentimage = down;
    } else if (over){
      currentimage = roll;
    } else {
      currentimage = base;
    }
  }
  
  void over() 
  {
    if( overRect(x, y, w, h) ) {
      over = true;
    } else {
      over = false;
    }
  }
  
  void display() 
  {
    image(currentimage, x, y);
  }
}


boolean overRect(int x, int y, int width, int height) 
{
  if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) {
    return true;
  } else {
    return false;
  }
}

