// Sprite (Teddy)
// by James Patterson <http://www.presstube.com> and REAS <http://www.groupc.net>
// based on the Sprite class by Glen Murphy <http://bodytag.org/>

// Demonstrates loading and displaying a transparent GIF image.

// Created 27 January 2003

Sprite teddy;

float xpos;
float ypos;
float drag = 30.0;

void setup() 
{
  size(200,200);
  teddy = new Sprite("teddy.gif");
  xpos = width/2;
  ypos = height/2;
}

void loop() 
{ 
  background(102);
  float difx = mouseX - xpos;
  if(abs(difx) > 1.0) {
    xpos = xpos + difx/drag;
    xpos = constrain(xpos, teddy.swidth/2, width-teddy.swidth/2-1);
  }  
  
  float dify = mouseY - ypos;
  if(abs(dify) > 1.0) {
    ypos = ypos + dify/drag;
    ypos = constrain(ypos, teddy.sheight/2, height-teddy.sheight/2-1);
  }  
  
  // Display the sprite at the position xpos, ypos
  teddy.display(xpos-teddy.swidth/2, ypos-teddy.sheight/2);
}

// Sprite class for transparent GIFs
class Sprite 
{
  int wh;       // Size of the sprite (width*height)
  int[] px;     // Array for storing the sprite
  int swidth;   // Width of the sprite
  int sheight;  // Height of the sprite
  BImage img;   // The image that is the sprite
	
  Sprite(String imageName) {
    loadSprite(imageName);
    swidth = img.width;
    sheight = img.height;
    wh = swidth*sheight;
    px = new int[wh];
    
    // Load the image into the px[] array
    for(int i=0; i < wh; i++) {
      px[i] = img.pixels[i];
    }
  }
  
  void loadSprite(String name) {
    img = loadImage(name);
  }
	
  void display(float x, float y) {
    int pix;
    for(int i=0; i < wh; i++) {
      // If the pixel of the image is not transparent, 
      // draw the pixel into the pixels[] array of the window
      if(px[i] != 0x00FFFFFF) {
        pix = (int)x+((int)y*width)+(i%swidth)+((i/swidth)*width);
        if(pix < width*height && pix > 0) { 
          pixels[pix] = px[i]; 
        }
      }
    }
  }
}


