// Objects
// By hbarragan

// Move the cursor across the image to change the speed and positions
// of the geometry. The class MRect defines a group of lines.

// Created 11 October 2002

MRect r1 = new MRect(1, 134.0, 0.532, 0.083*height, 10.0, 60.0);
MRect r2 = new MRect(2, 44.0, 0.166, 0.332*height, 5.0, 50.0);
MRect r3 = new MRect(2, 58.0, 0.332, 0.4482*height, 10.0, 35.0);
MRect r4 = new MRect(1, 120.0, 0.0498, 0.913*height, 15.0, 60.0);
 
void setup()
{
  size(200, 200);
  fill(255);
  noStroke();
}
 
void loop()
{
  background(0);
  
  r1.draw();
  r2.draw();
  r3.draw();
  r4.draw();
 
  r1.moveToX(mouseX-(width/2), 30);
  r2.moveToX((mouseX+(width*0.05))%width, 20);
  r3.moveToX(mouseX/4, 40);
  r4.moveToX(mouseX-(width/2), 50);
 
  r1.moveToY(mouseY+(height*0.1), 30);
  r2.moveToY(mouseY+(height*0.025), 20);
  r3.moveToY(mouseY-(height*0.025), 40);
  r4.moveToY((height-mouseY), 50);
}
 
class MRect 
{
  int W; // single bar width
  float xpos; // rect xposition
  float H; // rect height
  float ypos ; // rect yposition
  float D; // single bar distance
  float T; // number of bars
  float side; // rect width
 
  MRect(int w, float xp, float h, float yp, float d, float t) {
    W = w;
    xpos = xp;
    H = h;
    ypos = yp;
    D = d;
    T = t;
  }
 
  void moveToY (float posY, float damping) {
    float dif = ypos - posY;
    if (abs(dif) > 1) {
      ypos -= dif/damping;
    }
  }
 
  void moveToX (float posX, float damping) {
    float dif = xpos - posX;
    if (abs(dif) > 1) {
      xpos -= dif/damping;
    }
  }
 
  void draw() {
    for (int i = 0; i<T; i++) {
      rect(xpos+(i*D*W), ypos, W, height*H);
    }
  }
}
