// Binary Input
// by Mathias Dahlstrom <http://people.interaction-ivrea.it/m.dahlstrom>

// Example of a binary input from a BX-24 chip using serial communcation.
// Running this examples requires you have a BX-24 microcontroller
// and peripheral hardware. More information can be found on the tutorial 
// pages of Tom Igoe: http://stage.itp.nyu.edu/%7Etigoe/pcomp/examples.shtml
// Make sure to have the correct port selected in the "sketch" menu. Because 
// this program uses the serial port, it will not work within a web browser.

// Created 12 February 2003

// State of the circle drawing
boolean circleExpanding = true;

// Size of the circle
float circleSize = 0;

//The setup defines screen size and color setup.
void setup() 
{
  size(200, 200);  
  beginSerial(19200);
  noStroke();
  fill(204);
  ellipseMode(CENTER_RADIUS);
}

// The loop checks for what state the circle should be 
// drawn into and performs the drawing.
void loop() 
{
  background(0);
  
  if(circleExpanding) {
    ellipse(width/2, height/2, circleSize, circleSize);
    circleSize += 0.5;
  }else{
    ellipse(width/2, height/2, circleSize, circleSize);
    circleSize -= 0.5;
  }
  if(circleSize > width/2) {
    circleSize = width/2;
  }
  if(circleSize < 10) {
    circleSize = 10;
  }
}

// Function is called when ever a new byte from the 
// BX-24 is avaliable for reading.
// It controls what input the user is generating and 
// sets the corresponding drawing mode.
void serialEvent() 
{
  // Checks the ASCII code sent from the basicX chip. 
  // '48' is the code for '0' and '49' is the code for '1'
  if(serial == 48) {
    circleExpanding = false;
  }
  if(serial == 49) {
    circleExpanding = true;
  }
  println(serial);
}



// / / / / / / / / / / / / / / / / / / /

// Code for the BX-24 Microcontroller

/*
Option Explicit

dim inputVal as BYTE
dim lastVal as BYTE

Public Sub Main()
  Call PutPin(13,1)
  lastVal = 1
  Do
    inputVal = GetPin(13)
    If (inputVal <> lastVal) Then 
      If(inputVal = 0) Then
        debug.print "0"
      End if
      If(inputVal = 1) Then
        debug.print "1"
      End if			
    End if
    lastVal = inputVal
  Loop
End Sub
*/
